<template>
  <div>
    <v-layout>
      <v-flex>
        <v-card id="loginContentContainer"
          class="defaultCardBackground">
          <v-progress-linear
            v-if="submitRequested"
            :indeterminate="true"
            height="4"
            color="success"
            background-color="lightSuccess"
            style="height: 4px;position: absolute;top: -16px;">
          </v-progress-linear>
          <v-card-title>
            <h4 style="color:rgb(80, 130, 150)">
              Add User
            </h4>
          </v-card-title>
          <v-divider></v-divider>
          <form class="login"
            @submit.prevent="$v.$touch(); if($v.$error === false){addSeller()};">
            <v-layout row
              justify-space-around
              v-bind="gridResponsiveness">
              <v-flex xs6 id="userRegistrationGrid">
                <div class="defaultInputContainer"
                  v-bind:class="{ 'form-group--error': $v.firstName.$error }">
                  <input id="firstName"
                    class="inputDefault"
                    type="text"
                    v-model.trim="firstName"
                    @input="$v.firstName.$touch()"
                    v-on:input="$v.firstName.$touch"
                    v-bind:class="{
                      error: $v.firstName.$error,
                      valid: $v.firstName.$dirty && !$v.firstName.$invalid
                    }"/>
                  <label for="firstName"
                    class="defaultInputPlaceholder">
                    First name
                  </label>
                  <span class="formErrorMessage"
                    v-if="$v.firstName.$error && $v.firstName.$dirty">
                    Required
                  </span>
                  <v-icon style="color:#5A5"
                    v-if="$v.firstName.$dirty && !$v.firstName.$invalid">
                    check_circle
                  </v-icon>
                  <v-icon style="color:#FF6E40"
                    v-if="$v.firstName.$error && $v.firstName.$dirty">
                    cancel
                  </v-icon>
                </div>
                <div class="defaultInputContainer"
                  v-bind:class="{ 'form-group--error': $v.middleName.$error }">
                  <input id="middleName"
                    class="inputDefault"
                    type="text"
                    v-model.trim="middleName"
                    @input="$v.middleName.$touch()"
                    v-on:input="$v.middleName.$touch"
                    v-bind:class="{
                      error: $v.middleName.$error,
                      valid: $v.middleName.$dirty && !$v.middleName.$invalid
                    }"/>
                  <label for="middleName"
                    class="defaultInputPlaceholder">
                    Middle name
                  </label>
                  <span class="formErrorMessage"
                    v-if="$v.middleName.$error && $v.middleName.$dirty">
                    Required
                  </span>
                  <v-icon style="color:#5A5"
                    v-if="$v.middleName.$dirty && !$v.middleName.$invalid">
                    check_circle
                  </v-icon>
                  <v-icon style="color:#FF6E40"
                    v-if="$v.middleName.$error && $v.middleName.$dirty">
                    cancel
                  </v-icon>
                </div>
                <div class="defaultInputContainer"
                  v-bind:class="{ 'form-group--error': $v.lastName.$error }">
                  <input id="lastName"
                    class="inputDefault"
                    type="text"
                    v-model.trim="lastName"
                    @input="$v.lastName.$touch()"
                    v-on:input="$v.lastName.$touch"
                    v-bind:class="{
                      error: $v.lastName.$error,
                      valid: $v.lastName.$dirty && !$v.lastName.$invalid
                    }"/>
                  <label for="lastName"
                    class="defaultInputPlaceholder">
                    Last name
                  </label>
                  <span class="formErrorMessage"
                    v-if="$v.lastName.$error && $v.lastName.$dirty">
                    Required
                  </span>
                  <v-icon style="color:#5A5"
                    v-if="$v.lastName.$dirty && !$v.lastName.$invalid">
                    check_circle
                  </v-icon>
                  <v-icon style="color:#FF6E40"
                    v-if="$v.lastName.$error && $v.lastName.$dirty">
                    cancel
                  </v-icon>
                </div>
                <div class="defaultInputContainer"
                  v-bind:class="{ 'form-group--error': $v.userName.$error }">
                  <input id="userName"
                    class="inputDefault"
                    type="text"
                    v-model.trim="userName"
                    @input="$v.userName.$touch()"
                    v-on:input="$v.userName.$touch"
                    v-bind:class="{
                      error: $v.userName.$error,
                      valid: $v.userName.$dirty && !$v.userName.$invalid
                    }"/>
                  <label for="userName"
                    class="defaultInputPlaceholder">
                    User name
                  </label>
                  <span class="formErrorMessage"
                    v-if="$v.userName.$error && $v.userName.$dirty">
                    Required
                  </span>
                  <v-icon style="color:#5A5"
                    v-if="$v.userName.$dirty && !$v.userName.$invalid">
                    check_circle
                  </v-icon>
                  <v-icon style="color:#FF6E40"
                    v-if="$v.userName.$error && $v.userName.$dirty">
                    cancel
                  </v-icon>
                </div>
              </v-flex>
              <v-flex xs6 id="userRegistrationGrid">
                <div class="defaultInputContainer"
                  v-bind:class="{ 'form-group--error': $v.emailAdress.$error }">
                  <input id="emailAdress"
                    class="inputDefault"
                    type="email"
                    v-model.trim="emailAdress"
                    @input="$v.emailAdress.$touch()"
                    v-on:input="$v.emailAdress.$touch"
                    v-bind:class="{
                      error: $v.emailAdress.$error,
                      valid: $v.emailAdress.$dirty && !$v.emailAdress.$invalid
                    }"/>
                  <label for="emailAdress"
                    class="defaultInputPlaceholder">
                    Email adress
                  </label>
                  <span class="formErrorMessage"
                    v-if="!$v.emailAdress.required && $v.emailAdress.$dirty">
                    Required
                  </span>
                  <span class="formErrorMessage"
                    v-if="!$v.emailAdress.email && $v.emailAdress.$dirty">
                    Invalid email adress
                  </span>
                  <v-icon style="color:#5A5"
                    v-if="$v.emailAdress.$dirty && !$v.emailAdress.$invalid">
                    check_circle
                  </v-icon>
                  <v-icon style="color:#FF6E40"
                    v-if="$v.emailAdress.$error && $v.emailAdress.$dirty">
                    cancel
                  </v-icon>
                </div>
                <div class="defaultInputContainer"
                  v-bind:class="{ 'form-group--error': $v.userRole.$error }">
                  <input id="userRole"
                    class="inputDefault"
                    type="text"
                    v-model.trim="userRole"
                    @input="$v.userRole.$touch()"
                    v-on:input="$v.userRole.$touch"
                    v-bind:class="{
                      error: $v.userRole.$error,
                      valid: $v.userRole.$dirty && !$v.userRole.$invalid
                    }"/>
                  <label for="userRole"
                    class="defaultInputPlaceholder">
                    Role
                  </label>
                  <span class="formErrorMessage"
                    v-if="$v.userRole.$error && $v.userRole.$dirty">
                    Required
                  </span>
                  <v-icon style="color:#5A5"
                    v-if="$v.userRole.$dirty && !$v.userRole.$invalid">
                    check_circle
                  </v-icon>
                  <v-icon style="color:#FF6E40"
                    v-if="$v.userRole.$error && $v.userRole.$dirty">
                    cancel
                  </v-icon>
                </div>
                <div class="defaultInputContainer"
                  v-bind:class="{ 'form-group--error': $v.userPassword.$error }">
                  <input id="userPassword"
                    class="inputDefault"
                    type="password"
                    v-model.trim="userPassword"
                    @input="$v.userPassword.$touch()"
                    v-on:input="$v.userPassword.$touch"
                    v-bind:class="{
                      error: $v.userPassword.$error,
                      valid: $v.userPassword.$dirty && !$v.userPassword.$invalid
                    }"/>
                  <label for="userPassword"
                    class="defaultInputPlaceholder">
                    Password
                  </label>
                  <span class="formErrorMessage"
                    v-if="!$v.userPassword.required && $v.userPassword.$dirty">
                    Required
                  </span>
                  <span class="formErrorMessage"
                    v-if="!$v.userPassword.minLength">
                    Password must have at least 6 characters
                  </span>
                  <v-icon style="color:#5A5"
                    v-if="$v.userPassword.$dirty && !$v.userPassword.$invalid">
                    check_circle
                  </v-icon>
                  <v-icon style="color:#FF6E40"
                    v-if="$v.userPassword.$error && $v.userPassword.$dirty">
                    cancel
                  </v-icon>
                </div>
                <div class="defaultInputContainer"
                  v-bind:class="{ 'form-group--error': $v.repeatPasssword.$error }">
                  <input id="repeatPasssword"
                    class="inputDefault"
                    type="password"
                    v-model.trim="repeatPasssword"
                    @input="$v.repeatPasssword.$touch()"
                    v-on:input="$v.repeatPasssword.$touch"
                    v-bind:class="{
                      error: $v.repeatPasssword.$error,
                      valid: $v.repeatPasssword.$dirty && !$v.repeatPasssword.$invalid
                    }"/>
                  <label for="repeatPasssword"
                    class="defaultInputPlaceholder">
                    Repeat password
                  </label>
                  <span class="formErrorMessage"
                    v-if="!$v.repeatPasssword.required && $v.repeatPasssword.$dirty">
                    Required
                  </span>
                  <span class="formErrorMessage"
                    v-if="!$v.repeatPasssword.sameAsPassword && $v.repeatPasssword.$dirty">
                    Passwords must be identical.
                  </span>
                  <v-icon style="color:#5A5"
                    v-if="$v.repeatPasssword.$dirty && !$v.repeatPasssword.$invalid">
                    check_circle
                  </v-icon>
                  <v-icon style="color:#FF6E40"
                    v-if="$v.repeatPasssword.$error && $v.repeatPasssword.$dirty">
                    cancel
                  </v-icon>
                </div>
              </v-flex>
            </v-layout>
            <br/>
            <v-btn block
              dark
              depressed
              color="darkSecondary"
              type="submit"
              style="width:70%;margin: 0 auto;">
              ADD USER
            </v-btn>
            <br/><br/>
          </form>
        </v-card>
      </v-flex>
    </v-layout>
  </div>
</template>
<script>
import { required, email, minLength, sameAs } from 'vuelidate/lib/validators'
import axios from 'axios'
export default {
  name: 'AddUserComponent',
  data: () => ({
    firstName: undefined,
    middleName: undefined,
    lastName: undefined,
    userName: undefined,
    emailAdress: undefined,
    userRole: undefined,
    userPassword: undefined,
    repeatPasssword: undefined,
    name: '',
    text: '',
    submitRequested: false
  }),
  computed: {
    gridResponsiveness () {
      const gridResponsiveness = {}
      if (this.$vuetify.breakpoint.xs) gridResponsiveness.column = true
      return gridResponsiveness
    }
  },
  methods: {
    addSeller () {
      this.submitRequested = true
      axios.post('user', {
        firstName: this.firstName,
        middleName: this.middleName,
        lastName: this.lastName,
        userName: this.userName,
        email: this.emailAdress,
        role: this.userRole,
        password: this.userPassword
      }).then(response => {
        setTimeout(() => {
          this.submitRequested = false
          this.$router.push('/home/user_view/' + this.userName)
          this.$store.commit('SHOW_SUCCESS_SNACK_BAR', this.userName + ' user is succefully registered')
          this.$store.commit('UPDATE_ALL_USERS_LIST')
        }, 2000)
      })
        .catch(error => {
          this.submitRequested = false
          this.$store.commit('SHOW_ERROR_SNACK_BAR', 'User registration error: ' + error)
        })
    }
  },
  validations: {
    firstName: {
      required
    },
    middleName: {
      required
    },
    lastName: {
      required
    },
    userName: {
      required
    },
    emailAdress: {
      required,
      email
    },
    userRole: {
      required
    },
    userPassword: {
      required,
      minLength: minLength(6)
    },
    repeatPasssword: {
      required,
      sameAsPassword: sameAs('userPassword')
    }
  }
}
</script>
<style scoped>
.login{
    padding-top: 1px;
}
.error {
    border: 1px solid #FF6E40 !important;
    background: #ffffff !important;
  }
  .error:focus {
    outline-color: #F99;
  }
  .valid {
    border:1px solid #43A047 !important;
  }
  .valid:focus {
    outline-color: #43A047;
  }
#loginContentContainer{
  width: 80%;
  display: block;
  margin: 0 auto;
}

@media only screen and (max-width: 1190px){
  #loginContentContainer{
    width: 75% !important;
  }
}
@media only screen and (max-width: 900px){
  #loginContentContainer{
    width: 96% !important;
  }
}
@media only screen and (max-width: 650px){
  #userRegistrationGrid{
    width: 90% !important;
  }
}
@media only screen and (max-width: 480px){
  #loginContentContainer{
    width: 96% !important;
  }
}
</style>
